// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "dawn.hpp"
#include "display/Color.hpp"

namespace Dawn {
  class JSON final {
    public:
      /**
       * Parses the given JSON string as a vec3.
       * 
       * @param j JSON obj to parse.
       * @return Parsed vec3.
       */
      static glm::vec3 vec3(const json &j);

      /**
       * Parses the given JSON string as a color.
       * 
       * @param j JSON obj to parse.
       * @return Parsed color.
       */
      static struct Color color(const json &j);
  };
}